## libcdio 2.2.0

=== parse/Makefile ===
#   $Id: Makefile,v 1.5 2008/03/23 17:21:34 karl Exp $
#
#   Copyright (C) 2008 Rocky Bernstein <rocky@gnu.org>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

INCLUDES = -I .
all: cueparser cuelexer tocparser

lex.cue.c: cue.L cue.tab.h
	flex -Pcue cue.L

lex.cuelex.c: cue.L cue.tab.h
	flex -Pcuelex cue.L

lex.cue.o: lex.cue.c
	gcc -g -Wall -c lex.cue.c $(INCLUDES)

lex.cuelex.o: lex.cuelex.c
	gcc -g -DSTANDALONE -Wall -c lex.cuelex.c

cue.tab.c, cue.tab.h: cue.y
	bison -p cue -d cue.y

cue.tab.o: cue.tab.c cue.tab.h
	gcc -g -Wall -DSTANDALONE -c cue.tab.c $(INCLUDES)

cueparser: lex.cue.o cue.tab.o
	gcc -g lex.cue.o cue.tab.o -lfl -o cueparser

cuelexer: lex.cuelex.o 
	gcc -g lex.cuelex.o -lfl -o cuelexer

toc.tab.h: toc.tab.c

toc.tab.c: toc.y
	bison -p toc -d toc.y

toclexer.o: toclexer.c
	gcc -g -Wall -c toclexer.c $(INCLUDES)

toc.tab.o: toc.tab.c toc.tab.h
	gcc -g -Wall -DSTANDALONE -c toc.tab.c $(INCLUDES)

tocparser: toc.tab.o toclexer.o
	gcc -g toclexer.o toc.tab.o -o tocparser

clean: 
	rm -f lex.cue.c lex.cuelex.c lex.cue.o lex.cuelex.o cue.tab.c \
	    cue.tab.o cueparser cuelexer

check:
	(cd test && ./runall)

=== debian/changelog ===
libcdio (2.2.0-4) unstable; urgency=medium

  * Remove "Multi-Arch: same" from -dev packages (Closes: #897327)
    - As suggested by MultiArch Hinter:
      https://wiki.debian.org/MultiArch/Hints#file_conflict
  * Update Standards-Version.
  * Fix DEP-3 (Patch Tagging) warnings

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Wed, 02 Apr 2025 20:13:22 -0700

libcdio (2.2.0-3) unstable; urgency=medium

  * Add breaks between newer libcdio19 and older libiso9660-11

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Sun, 30 Mar 2025 16:16:11 -0700

libcdio (2.2.0-2) unstable; urgency=medium

  * Make libiso9660 explicitly depend on libcdio19t64 version 2.2.0.
    - The ABI change in libiso9660 causes segmentation faults when a process
      using libiso9660 dynamically links the older version of libcdio.
    - The update makes Debian's libiso9660-12 depend on libcdio19t64 version
      2.2.0, instead of the old 2.1.0.
    - Notice how libcdio19t64 did not have its SONAME bumped.
    - Do the same for libcdio++ since libiso9660 also had an ABI break.

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Thu, 13 Mar 2025 21:19:48 -0700

libcdio (2.2.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Fri, 07 Mar 2025 20:53:14 -0800

libcdio (2.2.0-1~exp1) experimental; urgency=low

  * New upstream version.
    - API changes to ecma_167.h:
      - Changes to struct member names.
    - ABI changes to libiso9660 and libiso9660++:
      - New struct member, u_su_fields, in iso_rock_statbuf_t.
      - New struct member, total_size, in iso9660_stat_t.
      - These types are used in libiso9660, libiso9660++, as well as in
        programs in libcdio-utils.
      - SONAMEs bumped to libiso9660.so.12 and libiso9660++.so.1 and the
        package names were updated accordingly, dropping the 't64' suffix from
        the 64-bits time_t transition.
  * Fix multi-arch availability for libcdio-dev (Closes: 897327)

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Sat, 25 Jan 2025 13:41:39 -0800

libcdio (2.1.0-5) unstable; urgency=medium

  [ Bruce Cable ]
  * SECURITY UPDATE: buffer overflow
    - debian/patches/CVE-2024-36600-1.patch: Allocates space for
      growth and additional buffer in lib/iso9660/rock.c
    - debian/patches/CVE-2024-36600-2.patch: Limits the maximum read
      count to prevent an overflow in lib/driver/_cdio_stdio.c
    - debian/patches/CVE-2024-36600-3.patch: Adds input validation to
      unicode16_decode function in lib/udf/udf_fs.c
    - debian/patches/CVE-2024-36600-4.patch: Adds bounds checking for
      directory buffer size and total size calculation in
      lib/iso9660/iso9660_fs.c
    - debian/patches/CVE-2024-36600-5.patch: Fixes overflow in iso9660
      dir read (32-bit) in lib/iso9660/iso9660_fs.c
    - debian/patches/CVE-2024-36600-6.patch: Checks the validity of
      i_extended_attr member in udf_get_lba() in lib/udf/udf_fs.c
    - debian/patches/CVE-2024-36600-7.patch: Adds 32-bit size test
      only when needed in lib/iso9660/iso9660_fs.c
    - CVE-2024-36600

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit (from ./configure),
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Alessandro Astone ]
  * Update optional symbols, resolves lintian error

  [ Gabriel F. T. Gomes ]
  * Fix lintian warning: Build-Depends on obsolete libncursesw5-dev.

 -- Gabriel F. T. Gomes <gabriel@debian.org>  Sat, 18 Jan 2025 15:40:54 -0800

libcdio (2.1.0-4.2) unstable; urgency=medium

  * Non-maintainer upload

  [ Zixing Liu ]
  * debian/patches/arm-t64-redirect-fix.patch: Fix implicit declaration
    after armhf time_t transition. (Closes: #1065778)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 12 Apr 2024 09:09:50 +0200

libcdio (2.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062245

 -- Lukas Märdian <slyon@debian.org>  Thu, 29 Feb 2024 10:35:17 +0000

=== debian/control ===
Source: libcdio
Priority: optional
Section: libs
Maintainer: Gabriel F. T. Gomes <gabriel@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  dctrl-tools | grep-dctrl,
  help2man,
  libpopt-dev,
  libncurses-dev,
  libcam-dev [kfreebsd-any],
  pkgconf,
  texinfo,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/libcdio.git
Vcs-Browser: https://salsa.debian.org/debian/libcdio
Homepage: https://www.gnu.org/software/libcdio/

Package: libcdio-dev
Section: libdevel
Architecture: any
Depends: libcdio19t64 (= ${binary:Version}), ${libcdev}, libcam-dev [kfreebsd-any], ${misc:Depends}
Description: library to read and control CD-ROM (development files)
 This package contains development files (headers and static library)
 for the libcdio library.
 .
 This library is to encapsulate CD-ROM reading and
 control. Applications wishing to be oblivious of the OS- and
 device-dependant properties of a CD-ROM can use this library.
 .
 Some support for disk image types like BIN/CUE and NRG is available,
 so applications that use this library also have the ability to read
 disc images as though they were CD's.

Package: libcdio++-dev
Section: libdevel
Architecture: any
Depends: libcdio++1t64 (= ${binary:Version}), ${libcxxdev}, libcdio-dev (= ${binary:Version}), ${misc:Depends}
Description: C++ library to read and control CD-ROM (development files)
 This package contains development files (headers and static library)
 for the libcdio++ library.
 .
 This library is to encapsulate CD-ROM reading and
 control. Applications wishing to be oblivious of the OS- and
 device-dependant properties of a CD-ROM can use this library.
 .
 Some support for disk image types like BIN/CUE and NRG is available,
 so applications that use this library also have the ability to read
 disc images as though they were CD's.

Package: libcdio19t64
Provides: ${t64:Provides}
Replaces: libcdio19
Breaks:
  libcdio19 (<< ${source:Version}),
  libiso9660-11 (<< 2.2.0),
  libiso9660-11t64 (<< 2.2.0),
  libiso9660++-0 (<< 2.2.0),
  libiso9660++-0t64 (<< 2.2.0)
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to read and control CD-ROM
 This library is to encapsulate CD-ROM reading and
 control. Applications wishing to be oblivious of the OS- and
 device-dependant properties of a CD-ROM can use this library.
 .
 Some support for disk image types like BIN/CUE and NRG is available,
 so applications that use this library also have the ability to read
 disc images as though they were CD's.

Package: libcdio++1t64
Provides: ${t64:Provides}
Replaces: libcdio++1
Breaks: libcdio++1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library to read and control CD-ROM
 This C++ library is to encapsulate CD-ROM reading and
 control. Applications wishing to be oblivious of the OS- and
 device-dependant properties of a CD-ROM can use this library.
 .
 Some support for disk image types like BIN/CUE and NRG is available,
 so applications that use this library also have the ability to read
 disc images as though they were CD's.

Package: libiso9660-dev
Section: libdevel
Architecture: any
Depends: libiso9660-12 (= ${binary:Version}), libcdio-dev (= ${binary:Version}), ${libcdev}, ${misc:Depends}
Description: library to work with ISO9660 filesystems (development files)
 This package contains development files (headers and static library)
 for the libiso9660 library.
 .
 This library is made to read and write ISO9660 filesystems; those
 filesystems are mainly used on CDROMs.

Package: libiso9660++-dev
Section: libdevel
Architecture: any
Depends: libiso9660++1 (= ${binary:Version}), libcdio++-dev (= ${binary:Version}), ${misc:Depends}
Description: C++ library to work with ISO9660 filesystems (development files)
 This package contains C++ development files (headers and static library)
 for the libiso9660 library.
 .
 This library is made to read and write ISO9660 filesystems; those
 filesystems are mainly used on CDROMs.

Package: libiso9660-12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libcdio19t64 (>= 2.2.0-2)
Description: library to work with ISO9660 filesystems
 This library is made to read and write ISO9660 filesystems; those
 filesystems are mainly used on CDROMs.

Package: libiso9660++1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libcdio19t64 (>= 2.2.0-2)
Description: C++ library to work with ISO9660 filesystems
 This C++ library is made to read and write ISO9660 filesystems; those
 filesystems are mainly used on CDROMs.

Package: libudf-dev
Section: libdevel
Architecture: any
Depends: libudf0t64 (= ${binary:Version}), libcdio-dev (= ${binary:Version}), ${libcdev}, ${misc:Depends}
Description: library to work with UDF filesystems (development files)
 This package contains development files (headers and static library)
 for the libudf library.
 .
 This library is made to read and write UDF filesystems; those
 filesystems are mainly used on DVDs.

Package: libudf0t64
Provides: ${t64:Provides}
Replaces: libudf0
Breaks: libudf0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to work with UDF filesystems
 This library is made to read and write UDF filesystems; those
 filesystems are mainly used on DVDs.

Package: libcdio-utils
Section: otherosfs
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sample applications based on the CDIO libraries
 This package contains a collection of small libcdio-based tools:
  * cd-drive      show CD-ROM drive characteristics
  * cd-info       show information about a CD or CD-image
  * cd-paranoia   an audio CD ripper
  * cd-read       read information from a CD or CD-image
  * cdda-player   a simple curses-based audio CD player
  * iso-info      show information about an ISO 9660 image
  * iso-read      read portions of an ISO 9660 image
  * mmc-tool      issue low-level commands to a CD drive

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -- --enable-maintainer-mode --disable-cddb --disable-vcd-info

override_dh_auto_install:
	dh_auto_install
	iconv \
	  -f iso8859-1 \
	  -t utf8 \
	  -o debian/tmp/usr/include/cdio/cd_types.h \
	  debian/tmp/usr/include/cdio/cd_types.h


%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libcdio-$1\.tar\.gz/ \
  https://github.com/libcdio/libcdio/tags .*/v?(\d\S+)\.tar\.gz
